// This file is part of the RecrutNid projet.
//
// (c) 2002, Free Software Foundation
//
// RecrutNid is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// RecrutNid is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with RecrutNid; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
// Petit programme de modlisation de la mobilisation chez la fourmi 
// Plus d'informations sur http://www.nojhan.fr.st/
// Auteur : Johann Dro <nojhan@ifrance.com>
// Date : 4 dcembre 2001
// version : 1.5

///////////////////////////// FONCTIONS PARTAGEE ///////////////////////////////
#include<vector>
using namespace std;

// cre une matrice 2D remplie de valeurs
vector< vector<int> > FilledMatrix( int DimL, int DimC, int FillValue);

// Transpose une matrice
vector< vector<float> > Transpose(vector< vector<float> > aMat);

// Oprations sur les lements d'un vecteur
float Sum(vector<float> aVector, int Begin=0, int During=0);
float Mean(vector<float> aVector, int Begin=0, int During=0);
float Std(vector<float> aVector, int Begin=0, int During=0);

// Transforme un [vecteur de] string en [vecteur de] float
vector<float> StringToFloat(vector<string> VString);
float StringToFloat(string aString);

// Transforme un string en vecteur de string (par sparateur)
void SplitString (string text, string separators, vector<string> & words);

// gnre un nombre alatoire suivant une loi normale
float rand_normal(float Mean, float Std);

// fonction de ou exclusif
int Xor(int cond1, int cond2);

