// This file is part of the RecrutNid projet.
//
// (c) 2002, Free Software Foundation
//
// RecrutNid is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// RecrutNid is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with RecrutNid; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
// Petit programme de modlisation de la mobilisation chez la fourmi 
// Plus d'informations sur http://www.nojhan.fr.st/
// Auteur : Johann Dro <nojhan@ifrance.com>
// Date : 4 dcembre 2001
// version : 1.5

#include <iostream>

#include <fstream>

#include <vector>

#include <string>

#include <cstdio>

#include "SharedFunc.h"
//FilledMatrix()

#include "Reader.h"

using namespace std;




//***** MakeNestMap(float DimL, float DimC, vector<float> VecL, vector<float> VecC) *****//
string MakeNestMap(float DimL, float DimC, vector<float> VecL, vector<float> VecC)
{// construit une carte du nid

    vector< vector<int> > NumMap;

    NumMap=FilledMatrix((int)DimL, (int)DimC, 0 );

    int i,j;
    for(i=0; i<VecL.size(); i++){//individus
        if((int)VecL[i]!=-99 && (int)VecC[i]){
            NumMap[ (int)VecL[i]-1 ][ (int)VecC[i]-1 ] += 1;
        }
    }

    string StringMap;

    StringMap+="|-";// premiere ligne
    for(j=0; j<NumMap[0].size(); j++){
        StringMap+="--";
    }
    StringMap+="|\n";

    for(i=0; i<NumMap.size(); i++){// intrieur du nid
        StringMap+="|";// dbut nouvelle ligne
        for(j=0; j<NumMap[i].size(); j++){
            StringMap+=" ";

            char Buffer[sizeof(long)]={'\0'};
            if(NumMap[i][j]==0){//si case vide
                Buffer[0]='.';//mettre un point
                Buffer[1]='\0';
            }else{
                //ltoa((long)NumMap[i][j], Buffer, 10);//mettre le chiffre (ANSI C ?)
                sprintf(Buffer, "%d", (long)NumMap[i][j]); // ANSI C !
            }

            StringMap+=Buffer;
        }
        StringMap+=" |\n";//fin de la ligne
    }//for(i)

    StringMap+="|-";// dernire ligne
    for(j=0; j<NumMap[0].size(); j++){
        StringMap+="--";
    }
    StringMap+="|\n";

    return StringMap;
}
//***** MakeNestMap(float DimL, float DimC, vector<float> VecL, vector<float> VecC) *****//




//***** WriteNestMaps(string OutFileName, int DimL, int DimC, vector< vectror<float> > MatL, vector< vectror<float> > MatC, int SimDebut, int SimFin, int SimPas) *****//
void WriteNestMaps(string &OutFileName,
                   int DimL, int DimC,
                   vector< vector<float> > MatL, vector< vector<float> > MatC,
                   int SimDebut, int SimFin, int SimPas)
{// crit les map  la suite du fichier de sortie

    string StringMap;

    ofstream OutFile;
    OutFile.open(OutFileName.c_str(), ios::out | ios::app); // ouvre en criture

    if(OutFile.is_open()){

        int i;
        for(i=SimDebut-1; i<SimFin; i+=SimPas){//simulations

            OutFile << endl << "ThisTurn\t" << i+1 << endl;

           StringMap = MakeNestMap(DimL, DimC, MatL[i], MatC[i]);
            OutFile << StringMap << endl;
        }//for(i)

    }else{
        cout << "<!> Impossible d'ouvrir le fichier de sortie : " << OutFileName << endl;
        return;
    }// if (is_open)

}
//***** WriteNestMaps(string OutFileName, int DimL, int DimC, vector< vectror<float> > MatL, vector< vectror<float> > MatC, int SimDebut, int SimFin, int SimPas) *****//




//***** MakeShow(string InFileName, string OutFileName, vector< string > SubOrders) *****//
void MakeShow(string InFileName, string OutFileName, vector<float> Values)
{// lit et crit plusieurs cartes du nid  diffrents temps

////////// LECTURE FICHIER ENTREE //////////
    ifstream InFile;
    InFile.open(InFileName.c_str(), ios::in); // ouvre en lecture

    if ( InFile.is_open() ) {
        InFile.close();

        vector<string> aOrders;// sous-ordres fictifs

        vector< vector<float> > MatL;
        vector< vector<float> > MatC;
        vector< vector<float> > DimL;
        vector< vector<float> > DimC;


        // lit les coordonnes
        aOrders.push_back("DoThat");
        aOrders.push_back("L");
        InFile.open(InFileName.c_str(), ios::in);
        MatL=ReadFile( InFile, "ByTime", aOrders);// isole les coord. Lignes
        InFile.close();

        aOrders.clear();
        aOrders.push_back("DoThat");
        aOrders.push_back("C");
        InFile.open(InFileName.c_str(), ios::in);
        MatC=ReadFile( InFile, "ByTime", aOrders);// isole les coord. Colonnes
        InFile.close();

        aOrders.clear();
        aOrders.push_back("DoThat");
        aOrders.push_back("DimL");
        InFile.open(InFileName.c_str(), ios::in);
        DimL=ReadFile( InFile, "ByTime", aOrders);
        InFile.close();

        aOrders.clear();
        aOrders.push_back("DoThat");
        aOrders.push_back("DimC");
        InFile.open(InFileName.c_str(), ios::in);
        DimC=ReadFile( InFile, "ByTime", aOrders);
        InFile.close();

        WriteNestMaps(OutFileName,
                      (int)DimL[0][0], (int)DimC[0][0],
                      MatL, MatC,
                      (int)Values[0], (int)Values[1], (int)Values[2]);

    }else{
        cout << "<!> Impossible d'ouvrir le fichier d'entree : " << InFileName << endl;
        return;
    }

}
//***** MakeShow(string InFileName, string OutFileName, vector< string > SubOrders) *****//
