// This file is part of the RecrutNid projet.
//
// (c) 2002, Free Software Foundation
//
// RecrutNid is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// RecrutNid is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with RecrutNid; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
// Petit programme de modlisation de la mobilisation chez la fourmi 
// Plus d'informations sur http://www.nojhan.fr.st/
// Auteur : Johann Dro <nojhan@ifrance.com>
// Date : 4 dcembre 2001
// version : 1.5

/////////////////////////// CLASSE FOURMI SIMPLE ///////////////////////////////

#include <vector>
// vector<>

#include <cstdlib>
// srand(), rand()

#include <cmath>
// abs()

using namespace std;

class itsBaseAnt
{
    //*** PROPRIETES ***//
    public :
        // VARIABLES ETAT
        int L, C; // coordonnes
        float Va, // Volume courant
              Vs, // Volume de satit
              Vmin; // Volume minimum

        float Motion; // activit de dplacement

        // FLAGS
        int isScout;
        int isOut;
        int isContact;
        int isGivingTropha;
        int isTakingTropha;

    //*** METHODES ***//
    public :

        // Flags
        void ResetTempFlags();

        // Trophallaxies
        float GiveVol(float aVol); // retourne  Va
        float TakeVol(float aVol); // retourne Va

        // Deplacements
        void GoOut();
        void GoIn(int atLine, int atColumn);

        // constructeur
        itsBaseAnt(int L, int C,
                       float Vmin, float Vs, float Va,
                       float Motion,
                       int isScout, int isOut,
                       int isContact, int isGivingTropha, int isTakingTropha);
}; //***** dclaration classe itsBaseAnt *****//




//***** constructeur : prend toutes les variables *****//
itsBaseAnt::itsBaseAnt(int L, int C,
                       float Vmin, float Vs, float Va,
                       float Motion,
                       int isScout, int isOut,
                       int isContact, int isGivingTropha, int isTakingTropha)
{

    this->L=L;
    this->C=C;
    this->Vmin=Vmin;
    this->Vs=Vs;
    this->Va=Va;
    this->Motion=Motion;
    this->isScout=isScout;
    this->isOut=isOut;
    this->isContact=isContact;
    this->isGivingTropha=isGivingTropha;
    this->isTakingTropha=isTakingTropha;

}//***** constructeur *****//



//***** GiveVol(float aVol) *****//
float itsBaseAnt::GiveVol(float aVol)
{
    isGivingTropha=1;
    Va=Va - aVol;
    return Va;
}//***** GiveVol( float aVol ) *****//



//***** TakeVol(float aVol) *****//
float itsBaseAnt::TakeVol(float aVol)
{
    isTakingTropha=1;
    Va=Va + aVol;
    return Va;
}//***** TakeVol(float aVol) *****//



//***** GoOut() *****//
void itsBaseAnt::GoOut()
{
    isOut=1;
    L=-99;
    C=-99;
}//***** GoOut() *****//



//***** GoIn( int atLine, int atColumn ) *****//
void itsBaseAnt::GoIn(int atLine, int atColumn)
{
    isOut=0;
    L = atLine;
    C = atColumn;
}//***** GoIn( int atLine, int atColumn ) *****//



//***** ResetTempFlags() *****//
void itsBaseAnt::ResetTempFlags()
{
    isContact=0;
    isGivingTropha=0;
    isTakingTropha=0;
}//***** ResetTempFlags() *****//

