// This file is part of the RecrutNid projet.
//
// (c) 2002, Free Software Foundation
//
// RecrutNid is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// RecrutNid is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with RecrutNid; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
// Petit programme de modlisation de la mobilisation chez la fourmi 
// Plus d'informations sur http://www.nojhan.fr.st/
// Auteur : Johann Dro <nojhan@ifrance.com>
// Date : 4 dcembre 2001
// version : 1.5

/////////////////////////// CLASSE FOURMI SIMPLE ///////////////////////////////
// regroupe les proprits d'une fourmi
// les mthodes doivent n'tre dfini que pour une fourmie  un temps donn

class itsBaseAnt
{
    //*** PROPRIETES ***//
    public :
        // VARIABLES ETAT
        int L, C; // coordonnes
        float Va, // Volume courant
              Vs, // Volume de satit
              Vmin; // Volume minimum

        float Motion; // activit de dplacement

        // FLAGS
        int isScout;
        int isOut;
        int isContact;
        int isGivingTropha;
        int isTakingTropha;

    //*** METHODES ***//
    public :

        // Flags
        void ResetTempFlags();

        // Trophallaxies
        float GiveVol(float aVol); // retourne  Va
        float TakeVol(float aVol); // retourne Va

        // Deplacements
        void GoOut();
        void GoIn(int atLine, int atColumn);

        // constructeur
        itsBaseAnt(int L, int C,
                       float Vmin, float Vs, float Va,
                       float Motion,
                       int isScout, int isOut,
                       int isContact, int isGivingTropha, int isTakingTropha);
}; //***** dclaration classe itsBaseAnt *****//

////////////////////////////// AJOUT DE MEMBRES ////////////////////////////////
// Mthodes  modifier en cas d'ajout de proprits dans la classe itsBaseAnt
//
// itsBaseAnt
//     Structurantes :
//          itsBaseAnt
//
// itsNest
//
//     Structurantes :
//          AddNewAnt
//          WriteNest
//     Logiques :
//          TryMeet
//          TryGoOut
//          TryMove
//
// itsScript
//     Structurantes :
//          DoOrders
