// This file is part of the RecrutNid projet.
//
// (c) 2002, Free Software Foundation
//
// RecrutNid is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// RecrutNid is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with RecrutNid; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
// Petit programme de modlisation de la mobilisation chez la fourmi 
// Plus d'informations sur http://www.nojhan.fr.st/
// Auteur : Johann Dro <nojhan@ifrance.com>
// Date : 4 dcembre 2001
// version : 1.5

///////////////////////////////// CLASSE NID ///////////////////////////////////
// proprit de l'ensemble des fourmis et d'un nid
// mthodes agissant sur le nid
// mthodes agissant sur plusieurs fourmis et/ou entre les 2 temps de la simulation

#include<vector>
using namespace std;

class itsNest
{
    //*** PROPRIETES ***//
  public :
    int DimL, DimC; // dimensions du nid
    int TotalTurn; // nombre d'itrations
    int TotalAnts; // nb de fourmis
    int ThisTurn; // n d'itration

//  protected :
    vector<itsBaseAnt> CurAnts; // le vecteur de toutes les fourmis  t
    vector<itsBaseAnt> NextAnts; // le mme  t+1

    //*** METHODES ***//
  public :
    void SetDim(int aDimL, int aDimC); // initialisation des dimensions

    // Ajoute une fourmi
    void AddNewAnt(int L, int C,
                       float Vmin, float Vs, float Va,
                       float Motion,
                       int isScout, int isOut,
                       int isContact,
                       int isGivingTropha, int isTakingTropha);// renvoie le n de la nouvelle fourmi
    void Simulate(int aTotalTurn, string aFileName); // lance le calcul sur le nid
    void WriteNest(string aFileName); // sauve le nid courant
    int EndTurn(int aTurn); // un tour de plus
    itsNest();// constructeur

  protected :

    // Tente de faire un trophallaxie entre deux fourmis
    int TryMeet(int Ant1, int Ant2);
    // tente de sortir la fourmi
    int TryGoOut(int AntNb);
    // tente de bouger
    int TryMove(int AntNb);

    void PutOut(int AntNb); // sort la fourmi avec le n AntNb
    void PutIn(int AntNb, int atLine, int atColumn); // rentre la fourmi...
    void ResetTempFlags(); // met les flags d'action  0

};//***** dclaration de classe *****//

////////////////////////////// AJOUT DE MEMBRES ////////////////////////////////

