// This file is part of the RecrutNid projet.
//
// (c) 2002, Free Software Foundation
//
// RecrutNid is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// RecrutNid is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with RecrutNid; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
// Petit programme de modlisation de la mobilisation chez la fourmi 
// Plus d'informations sur http://www.nojhan.fr.st/
// Auteur : Johann Dro <nojhan@ifrance.com>
// Date : 4 dcembre 2001
// version : 1.5

/////////////////////////////// CLASSE SCRIPTE /////////////////////////////////

class itsScript
{
    //*** PROPRIETES ***//
    public :
        string ScriptFileName; // nom du fichier script en cours
        string SaveFileName; // Fichier de sauvegarde
        string InFileName; // fichier d'entree
        itsNest TheNest;
        //itsReader TheReader;

    protected :
        vector<string> TheScript; // tout le script

        string CurLine; // Ligne
        string CurOrder; // instruction
        vector<string> CurParameters; // paramtres non interprts
        vector<float> CurValues; // paramtres interprts

        vector<float> CurAntVars; // values de la fourmi en cours
        vector<string> CurAntParameters; // param de la fourmi en cours

    //*** METHODES ***//
    public :
        void LoadScript(string aFileName); // charge le fichier script
        void DoScript(); // Execute le script

    protected :
            //void ReadNextLine(); // isole la prochaine ligne
            string ReadOrder(string aCurLine); // isole l'instruction
            vector<string> ReadParameters(string aCurLine); // isole les paramtres

            vector<float> DoParameters(vector<string> aCurParameters); // calcul des paramtres

            //void DoOrders();
            int DoOrders(int iLine); // Execute les instructions

}; //***** dclaration classe itsScript *****//
